package org.omg.CosNaming;

import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.portable.ObjectImpl;
import org.omg.CORBA.Object;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;

public abstract class NamingContextExtHelper
{
    private static String _id;
    private static TypeCode __typeCode;
    
    public NamingContextExtHelper() {
    }
    
    public static void insert(Any any, NamingContextExt namingContextExt) {
        OutputStream create_output_stream = any.create_output_stream();
        any.type(type());
        write(create_output_stream, namingContextExt);
        any.read_value(create_output_stream.create_input_stream(), type());
    }
    
    public static NamingContextExt extract(Any any) {
        return read(any.create_input_stream());
    }
    
    public static synchronized TypeCode type() {
        if (NamingContextExtHelper.__typeCode == null) {
            NamingContextExtHelper.__typeCode = ORB.init().create_interface_tc(id(), "NamingContextExt");
        }
        return NamingContextExtHelper.__typeCode;
    }
    
    public static String id() {
        return NamingContextExtHelper._id;
    }
    
    public static NamingContextExt read(InputStream inputStream) {
        return narrow(inputStream.read_Object(_NamingContextExtStub.class));
    }
    
    public static void write(OutputStream outputStream, NamingContextExt namingContextExt) {
        outputStream.write_Object(namingContextExt);
    }
    
    public static NamingContextExt narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof NamingContextExt)) {
            return (NamingContextExt)object;
        }
        if (!object._is_a(id())) {
            throw new BAD_PARAM();
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _NamingContextExtStub namingContextExtStub = new _NamingContextExtStub();
        namingContextExtStub._set_delegate(get_delegate);
        return namingContextExtStub;
    }
    
    public static NamingContextExt unchecked_narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof NamingContextExt)) {
            return (NamingContextExt)object;
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _NamingContextExtStub namingContextExtStub = new _NamingContextExtStub();
        namingContextExtStub._set_delegate(get_delegate);
        return namingContextExtStub;
    }
    
    static {
        NamingContextExtHelper._id = "IDL:omg.org/CosNaming/NamingContextExt:1.0";
        NamingContextExtHelper.__typeCode = null;
    }
}
